// Copyright (c) 2003-2010 Christopher M. Kohlhoff
// Modifications (c) 2011 by Guilherme Maciel Ferreira / Intra2net AG
//
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)
#ifndef ICMP_TYPE_H
#define ICMP_TYPE_H

enum Icmpv4Type
{
    Icmpv4Type_EchoReply = 0,
    Icmpv4Type_DestinationUnreachable = 3,
    Icmpv4Type_SourceQuench = 4,
    Icmpv4Type_Redirect = 5,
    Icmpv4Type_EchoRequest = 8,
    Icmpv4Type_TimeExceeded = 11,
    Icmpv4Type_ParameterProblem = 12,
    Icmpv4Type_TimestampRequest = 13,
    Icmpv4Type_TimestampReply = 14,
    Icmpv4Type_InfoRequest = 15,
    Icmpv4Type_InfoReply = 16,
    Icmpv4Type_AddressRequest = 17,
    Icmpv4Type_AddressReply = 18,
    Icmpv4Type_InvalidLast = 42,
    Icmpv4Type_Generic = 43
};

enum Icmpv6Type
{
    Icmpv6Type_First = 0,
    // ICMPv6 Error Messages
    Icmpv6Type_DestinationUnreachable = 1,
    Icmpv6Type_PacketTooBig = 2,
    Icmpv6Type_TimeExceeded = 3,
    Icmpv6Type_ParameterProblem = 4,
    // ICMPv6 Informational Messages
    Icmpv6Type_EchoRequest = 128,
    Icmpv6Type_EchoReply = 129,
    Icmpv6Type_RouterSolicitation = 133,
    Icmpv6Type_RouterAdvertisement = 134,
    Icmpv6Type_NeighborSolicitation = 135,
    Icmpv6Type_NeighborAdvertisement = 136,
    Icmpv6Type_RedirectMessage = 137,
    Icmpv6Type_RouterRenumbering = 138,
    Icmpv6Type_ICMPNodeInformationQuery = 139,
    Icmpv6Type_ICMPNodeInformationResponse = 140,
    Icmpv6Type_InverseNeighborDiscoverySolicitationMessage = 141,
    Icmpv6Type_InverseNeighborDiscoveryAdvertisementMessage = 142,
    Icmpv6Type_MulticastListenerDiscovery = 143,
    Icmpv6Type_HomeAgentAddressDiscoveryRequestMessage = 144,
    Icmpv6Type_HomeAgentAddressDiscoveryReplyMessage = 145,
    Icmpv6Type_MobilePrefixSolicitation = 146,
    Icmpv6Type_MobilePrefixAdvertisement = 147,
    Icmpv6Type_CertificationPathSolicitation = 148,
    Icmpv6Type_CertificationPathAdvertisement = 149,
    Icmpv6Type_MulticastRouterAdvertisement = 151,
    Icmpv6Type_MulticastRouterSolicitation = 152,
    Icmpv6Type_MulticastRouterTermination = 153,
    Icmpv6Type_InvalidLast = 254,
    Icmpv6Type_Generic = 255
};

#endif // ICMP_TYPE_H
